import React from 'react';

export default React.createClass({
  displayName: 'Teaser',
  propTypes: {
    section: React.PropTypes.string,
    sectionPages: React.PropTypes.func,
    amount: React.PropTypes.number
  },
  getDefaultProps() {
    return {
      amount: 1
    };
  },
  render: function() {
    var section = this.props.section;
    var amount = this.props.amount;
    var pages = this.props.sectionPages(section).slice(0, amount);

    return pages.length > 1 ?
      this.renderMultiple(pages) :
      this.renderSingle(pages[0]);
  },
  renderMultiple(pages) {
    return (
      <ul className='teasers'>
        {pages.map((page, i) => {
          return <li key={'teaser-' + i}>{this.renderSingle(page)}</li>;
        })}
      </ul>
    );
  },
  renderSingle(page) {
    if(page) {
      return <a className='teaser' href={'/' + page.url}>{page.title}</a>;
    }
  }
});
